unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, DBTables, DBSecur, Db, LoginDlg, ExtCtrls;

type
  TPasswordType = (ptUser, ptSession);

  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBSecurity: TDBSecurity;
    Database1: TDatabase;
    Table2: TTable;
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    Button2: TButton;
    Button1: TButton;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    function DBSecurityChangePassword(UsersTable: TTable;
      const OldPassword, NewPassword: String): Boolean;
    function DBSecurityCheckUser(UsersTable: TTable;
      const Password: String): Boolean;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FPasswordToSet : TPasswordType;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

resourcestring
  EOldPasswordIsIncorrect = 'Entered current password is not correct';

implementation

uses PwdScrty;

{$R *.DFM}

function TForm1.DBSecurityChangePassword(UsersTable: TTable;
  const OldPassword, NewPassword: String): Boolean;
var S : string;
    CS : TCryptStream;
    Stream : TBlobStream;
    I : Integer;
begin

  if FPasswordToSet = ptUser then {User password}
    begin
       I := 1;
       S := DBSecurity.LoggedUser;
    end
  else {Session password}
    begin
      I := 0;
      S := DBGrid1.DataSource.DataSet.FieldByName('USERNAME').AsString;
    end;
  CS := TCryptStream.Create;
  with UsersTable do
    try
      if not Locate('USERNAME', S, []) then raise Exception.Create('Couldn''t locate user');
      Edit;
      Stream := TBlobStream.Create(TBlobField(FieldByName('PASSWORDS')), bmReadWrite);
      CS.LoadFromStream(Stream);
      if CS.Size = 0 then S:= ''
      else S := CS.Words[I];
      if OldPassword <> S then
        raise Exception.Create(EOldPasswordIsIncorrect);
      if CS.Count < 2 then CS.Count := 2; {If password data was empty}
      CS.Words[I] := NewPassword;
      Stream.Position := 0;
      Stream.Truncate;
      CS.SaveToStream(Stream);
      Post;
      Result := True;
    finally
      CS.Free;
      Stream.Free;
    end;
end;

function TForm1.DBSecurityCheckUser(UsersTable: TTable;
  const Password: String): Boolean;
var S : string;
    CS : TCryptStream;
    Stream : TBlobStream;
begin
  Result := False;
  S := '';
  CS := TCryptStream.Create;
  try
    Session.AddPassword('Guest'); {Users table has to have Read-Only auxiluary password}
    with UsersTable do
      Stream := TBlobStream(CreateBlobStream(FieldByName('PASSWORDS'), bmRead));
    CS.LoadFromStream(Stream);
    if CS.Count = 0 then S := ''
    else S := CS.Words[1];
    if not (Password = S) then raise Exception.Create('Login failed');
    if CS.Count = 0 then S := ''
    else S := CS.Words[0];
    Session.RemoveAllPasswords;
    Session.AddPassword(S);
    Result := True;
  finally
    CS.Free;
    Stream.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FPasswordToSet := ptUser;
  DBSecurity.ChangePassword;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  FPasswordToSet := ptSession;
  DBSecurity.ChangePassword;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Table1.Open;
  Table2.Open;
end;

end.
